## laszip 3.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(LASZIP CXX C)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

set(ROOT_DIR "${PROJECT_SOURCE_DIR}")

# the next line is the ONLY place in the entire laszip system where
# the version info is hard-coded
set(LASZIP_API_VERSION_STRING "3.4.1" CACHE STRING "LASzip version" FORCE)

include (CheckIncludeFileCXX)
include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)
include(${ROOT_DIR}/cmake/cpack.cmake NO_POLICY_SCOPE)

#------------------------------------------------------------------------------
# internal cmake settings
#------------------------------------------------------------------------------

set(CMAKE_COLOR_MAKEFILE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
include(FeatureSummary)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

#------------------------------------------------------------------------------
# LASZIP general settings
#------------------------------------------------------------------------------


#
# Extract the pieces of the version info from the version string above.
DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()


set(LASZIP_API_VERSION ${LASZIP_API_VERSION_MAJOR}.${LASZIP_API_VERSION_MINOR}.${LASZIP_API_VERSION_PATCH})

# libtool SO version naming
# 8.0.0 for 3.2.1
# 9.0.0 for 4.0+
set(LASZIP_SO_VERSION "8.0.4")
set(LASZIP_COMPATIBILITY_VERSION 8)

check_include_file_cxx ("unordered_map" HAVE_UNORDERED_MAP)

###############################################################################
# Main CMake configuration file for laszip
#
# Author: Mateusz Loskot <mateusz@loskot.net>
#
#
###############################################################################
# laszip general settings

set(LASZIP_API_VERSION_H
    ${CMAKE_CURRENT_BINARY_DIR}/include/laszip/laszip_api_version.h)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/laszip_api_version.h.in
    ${LASZIP_API_VERSION_H})

set(LASZIP_BASE_LIB_NAME laszip)
set(LASZIP_API_LIB_NAME laszip_api)

if(WIN32)
    set(LASZIP_BASE_LIB_NAME "${LASZIP_BASE_LIB_NAME}${LASZIP_API_VERSION_MAJOR}")
    set(LASZIP_API_LIB_NAME "${LASZIP_API_LIB_NAME}${LASZIP_API_VERSION_MAJOR}")
endif()


set(LASZIP_OUTPUT_LIB_DIR "${LASZIP_BINARY_DIR}/${LASZIP_LIB_INSTALL_DIR}")
set(LASZIP_OUTPUT_BIN_DIR "${LASZIP_BINARY_DIR}/${LASZIP_BIN_INSTALL_DIR}")
set(LASZIP_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${LASZIP_LIB_INSTALL_DIR}")
file(MAKE_DIRECTORY "${LASZIP_OUTPUT_LIB_DIR}")
file(MAKE_DIRECTORY "${LASZIP_OUTPUT_BIN_DIR}")

# per http://www.cmake.org/Wiki/CMake_RPATH_handling
SET(CMAKE_SKIP_BUILD_RPATH FALSE)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
IF (APPLE)
    SET(MACOSX_RPATH ON)
endif()
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES
    "${CMAKE_INSTALL_PREFIX}/${LASZIP_LIB_INSTALL_DIR}" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LASZIP_LIB_INSTALL_DIR}")
ENDIF("${isSystemDir}" STREQUAL "-1")

# wipe lib/ drectory on clean. It will have plugins that could be out of date
# in the next build
set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES "${LASZIP_OUTPUT_LIB_DIR}/*")

if(WIN32)
  add_definitions("-DLASZIP_DLL_EXPORT=1")
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${LASZIP_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${LASZIP_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${LASZIP_OUTPUT_BIN_DIR}")
  endforeach(config)
else(WIN32)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${LASZIP_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${LASZIP_OUTPUT_BIN_DIR}")
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${LASZIP_OUTPUT_LIB_DIR}")
endif(WIN32)

set(LASZIP_HEADERS_DIR "${PROJECT_SOURCE_DIR}/include/laszip")

add_subdirectory(src)
add_subdirectory(dll)

#
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== debian/changelog ===
laszip (3.4.1-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 19 May 2019 17:14:17 +0200

laszip (3.4.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop buildflags.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 13 Apr 2019 06:56:58 +0200

laszip (3.4.0-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #750731)

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 01 Apr 2019 21:35:11 +0200

=== debian/control ===
Source: laszip
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: chrpath,
               cmake (>= 2.8.11),
               debhelper (>= 9)
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/laszip
Vcs-Git: https://salsa.debian.org/debian-gis-team/laszip.git
Homepage: http://www.laszip.org/

Package: liblaszip8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Lossless LiDAR compression - shared library
 LASzip quickly turns bulky LAS files into compact LAZ files without
 information loss.
 .
 This package contains the shared library.

Package: liblaszip-api8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Lossless LiDAR compression - API shared library
 LASzip quickly turns bulky LAS files into compact LAZ files without
 information loss.
 .
 This package contains the API shared library.

Package: liblaszip-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liblaszip8 (= ${binary:Version}),
         liblaszip-api8 (= ${binary:Version}),
         ${misc:Depends}
Description: Lossless LiDAR compression - development files
 LASzip quickly turns bulky LAS files into compact LAZ files without
 information loss.
 .
 This package contains development files.

## laszip 3.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 # the next line is the ONLY place in the entire laszip system where
 # the version info is hard-coded
-set(LASZIP_API_VERSION_STRING "3.4.1" CACHE STRING "LASzip version" FORCE)
+set(LASZIP_API_VERSION_STRING "3.4.3" CACHE STRING "LASzip version" FORCE)
 
 include (CheckIncludeFileCXX)
 include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)
@@ -41,7 +41,7 @@
 # libtool SO version naming
 # 8.0.0 for 3.2.1
 # 9.0.0 for 4.0+
-set(LASZIP_SO_VERSION "8.0.4")
+set(LASZIP_SO_VERSION "8.0.5")
 set(LASZIP_COMPATIBILITY_VERSION 8)
 
 check_include_file_cxx ("unordered_map" HAVE_UNORDERED_MAP)

=== src/CMakeLists.txt ===
###############################################################################
#
# src/CMakeLists.txt controls building of laszip library
#
# Copyright (c) 2009 Mateusz Loskot <mateusz@loskot.net>
#
###############################################################################
set(LASZIP_SOURCES
    arithmeticdecoder.cpp
    arithmeticencoder.cpp
    arithmeticmodel.cpp
    integercompressor.cpp
    lasindex.cpp
    lasinterval.cpp
    lasquadtree.cpp
    lasreaditemcompressed_v1.cpp
    lasreaditemcompressed_v2.cpp
    lasreaditemcompressed_v3.cpp
    lasreaditemcompressed_v4.cpp
    lasreadpoint.cpp
    laswriteitemcompressed_v1.cpp
    laswriteitemcompressed_v2.cpp
    laswriteitemcompressed_v3.cpp
    laswriteitemcompressed_v4.cpp
    laswritepoint.cpp
    laszip.cpp
    laszip_dll.cpp
    mydefs.cpp
)

add_definitions(-DLASZIPDLL_EXPORTS)
add_definitions(-DUNORDERED)

if(HAVE_UNORDERED_MAP)
    add_definitions(-DHAVE_UNORDERED_MAP=1)
endif(HAVE_UNORDERED_MAP)
LASZIP_ADD_LIBRARY(${LASZIP_BASE_LIB_NAME} ${LASZIP_SOURCES})

=== debian/changelog ===
laszip (3.4.3-2) unstable; urgency=medium

  * Drop Name field from upstream metadata.
  * Bump Standards-Version to 4.5.0, no changes.
  * Bump debhelper compat to 10, changes:
    - Drop --parallel option, enabled by default
  * Bump watch file version to 4.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 11 Nov 2020 18:27:07 +0100

laszip (3.4.3-1) unstable; urgency=medium

  * New upstream release.
  * Update Homepage URL to use HTTPS.
  * Bump Standards-Version to 4.4.1, no changes.
  * Add lintian override for shared-lib-without-dependency-information.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 12 Nov 2019 05:41:08 +0100

laszip (3.4.1-2) unstable; urgency=medium

  * Update gbp.conf to use --source-only-changes by default.
  * Bump Standards-Version to 4.4.0, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 07 Jul 2019 08:25:03 +0200

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,11 @@
 Priority: optional
 Build-Depends: chrpath,
                cmake (>= 2.8.11),
-               debhelper (>= 9)
-Standards-Version: 4.3.0
+               debhelper (>= 10~)
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/laszip
 Vcs-Git: https://salsa.debian.org/debian-gis-team/laszip.git
-Homepage: http://www.laszip.org/
+Homepage: https://laszip.org/
 
 Package: liblaszip8
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Remove buildpath from binaries
export DEB_CFLAGS_MAINT_APPEND=-DNDEBUG
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)

override_dh_install:
	dh_install --list-missing

	# Strip RPATH
	chrpath --delete debian/*/usr/lib/*/*.so.?.?.?

override_dh_makeshlibs:
	dh_makeshlibs -V

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)-?(\d*)$/$1~$2$3/;s/RC/rc/,\
filenamemangle=s/(?:.*?)?(?:rel|v|LASzip)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/LASzip-$1.$2/ \
https://github.com/LASzip/LASzip/releases \
(?:.*?/archive/)?(?:rel|v|LASzip)?[\-\_]?(\d+\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## laszip 3.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.11)
+cmake_minimum_required(VERSION 3.10)
 
 project(LASZIP CXX C)
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
@@ -7,7 +7,7 @@
 
 # the next line is the ONLY place in the entire laszip system where
 # the version info is hard-coded
-set(LASZIP_API_VERSION_STRING "3.4.3" CACHE STRING "LASzip version" FORCE)
+set(LASZIP_API_VERSION_STRING "3.5.0" CACHE STRING "LASzip version" FORCE)
 
 include (CheckIncludeFileCXX)
 include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)
@@ -41,7 +41,7 @@
 # libtool SO version naming
 # 8.0.0 for 3.2.1
 # 9.0.0 for 4.0+
-set(LASZIP_SO_VERSION "8.0.5")
+set(LASZIP_SO_VERSION "8.0.6")
 set(LASZIP_COMPATIBILITY_VERSION 8)
 
 check_include_file_cxx ("unordered_map" HAVE_UNORDERED_MAP)

=== dll/CMakeLists.txt ===

set(LASZIP_API_SOURCES
    laszip_api.c
)

LASZIP_ADD_LIBRARY(${LASZIP_API_LIB_NAME} ${LASZIP_API_SOURCES})
LASZIP_ADD_INCLUDES("laszip" "${LASZIP_HEADERS_DIR}/laszip_api.h" ${LASZIP_API_VERSION_H})

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/LASzip.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/LASzip.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/LASzip"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/LASzip"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== example/CMakeLists.txt ===
###############################################################################
#
# tools/CMakeLists.txt controls building of laszip utilities 
#
# Copyright (c) 2009 Mateusz Loskot <mateusz@loskot.net>
#
###############################################################################

include_directories(
    .
    ../include
    ../include/laszip)


set(APPS_CPP_DEPENDENCIES
    ${LASZIP_LIB_NAME})
    

set(LASZIPPERTEST laszippertest)


set(LASZIP_UTILITIES
    ${LASZIPPERTEST}
    )
    
if(WIN32)
if(NOT BUILD_STATIC)
    add_definitions("-DLASZIP_DLL_IMPORT=1")
endif()
endif()


# TODO: Experimental and requires testing --mloskot
# Generate user-specific settings for Visual Studio project
set(VCPROJ_USER_REMOTE_MACHINE_DEBUG ${MACHINE_NAME})
set(VCPROJ_USER_ENVIRONMENT_DEBUG "${ENVIRONMENT_PATH}")

if(MSVC)
    foreach(utility ${LASZIP_UTILITIES})
        set(USER_FILE ${utility}.vcproj.$ENV{USERDOMAIN}.$ENV{USERNAME}.user)
        set(OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/${USER_FILE})
        message(STATUS "Generating ${CMAKE_GENERATOR} user-specific settings in ${USER_FILE}")
        configure_file(${CMAKE_SOURCE_DIR}/cmake/laszip.vcproj.user.template ${OUTPUT_PATH} @ONLY)
    endforeach()
endif()


if(LASZIPPERTEST)
    add_executable(${LASZIPPERTEST} laszippertest.cpp)
    target_link_libraries(${LASZIPPERTEST} ${APPS_CPP_DEPENDENCIES} )
    if (EMSCRIPTEN)
        SET_TARGET_PROPERTIES(${LASZIPPERTEST} PROPERTIES SUFFIX .js)
    endif()
endif()


if(UNIX)
    # Autoconf compatibility variables to use the same script source.
    set(prefix ${CMAKE_INSTALL_PREFIX})
    set(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
    set(libdir ${CMAKE_INSTALL_PREFIX}/lib)

    GET_DIRECTORY_PROPERTY(LASZIP_DEFINITIONS DIRECTORY ${laszip_SOURCE_DIR}/ COMPILE_DEFINITIONS)   

    set(LASZIP_CONFIG_DEFINITIONS "")
    foreach(definition ${LASZIP_DEFINITIONS})
        set(LASZIP_CONFIG_DEFINITIONS "${LASZIP_CONFIG_DEFINITIONS} -D${definition}")
    endforeach()

 
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/laszip-config.in
      ${CMAKE_CURRENT_BINARY_DIR}/laszip-config @ONLY)
  
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/laszip-config
      DESTINATION bin/
      PERMISSIONS
      OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

    #pkgconfig
    set(PKGCFG_PREFIX "${CMAKE_INSTALL_PREFIX}")
    set(PKGCFG_INC_DIR "${CMAKE_INSTALL_PREFIX}/${LIBLAS_INCLUDE_SUBDIR}")
    set(PKGCFG_LIB_DIR "${CMAKE_INSTALL_PREFIX}/${LIBLAS_LIB_SUBDIR}")
    set(PKGCFG_REQUIRES  "")
    set(PKGCFG_VERSION ${VERSION})
    set(PKGCFG_LINK_FLAGS "-llaszip")
    set(PKGCFG_COMPILE_FLAGS "$CMAKE_CXX_FLAGS")
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/laszip.pc.in
      ${CMAKE_CURRENT_BINARY_DIR}/laszip.pc @ONLY)

  
endif(UNIX)
###############################################################################
# Targets installation

install(TARGETS ${LASZIP_UTILITIES}
    RUNTIME DESTINATION ${LASZIP_BIN_DIR}
    LIBRARY DESTINATION ${LASZIP_LIB_DIR}
    ARCHIVE DESTINATION ${LASZIP_LIB_DIR})

=== debian/changelog ===
laszip (3.5.0-2) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Fix Vcs-* URLs for science-team repo.

  [ Timo Röhling ]
  * Bump Standards-Version to 4.7.0

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Apr 2024 13:32:44 +0200

laszip (3.5.0-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Update upstream metadata.
  * Update debian/watch file

  [ Timo Röhling ]
  * New upstream version 3.5.0
  * Reintroducing laszip.
    Thanks to Bas Couwenberg for his work and for handing over the package
    to the Science Team.
  * Update packaging
    - Bump Standards-Version to 4.6.2
    - Bump debhelper to level 13
  * Relicensed under Apache-2.0

 -- Timo Röhling <roehling@debian.org>  Wed, 08 Nov 2023 20:34:57 +0100

=== debian/control ===
Source: laszip
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/laszip
Vcs-Git: https://salsa.debian.org/science-team/laszip.git
Homepage: https://laszip.org/
Description: Lossless LiDAR compression
 LASzip quickly turns bulky LAS files into compact LAZ files without
 information loss.

Package: liblaszip8
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: ${source:Synopsis} - shared library
 ${source:Extended-Description}
 .
 This package contains the shared library.

Package: liblaszip-api8
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 liblaszip8 (= ${binary:Version}),
Pre-Depends:
 ${misc:Pre-Depends},
Description: ${source:Synopsis} - API shared library
 ${source:Extended-Description}
 .
 This package contains the API shared library.

Package: liblaszip-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 liblaszip-api8 (= ${binary:Version}),
 liblaszip8 (= ${binary:Version}),
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains development files.

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)-?(\d*)$/$1~$2$3/;s/RC/rc/,\
filenamemangle=s/(?:.*?)?(?:rel|v|LASzip)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/LASzip-$1.$2/ \
https://github.com/LASzip/LASzip/tags \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|LASzip)?[\-\_]?(\d+\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## laszip 3.5.0+really3.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,25 @@
 cmake_minimum_required(VERSION 3.10)
 
 project(LASZIP CXX C)
+set(CMAKE_CXX_STANDARD 17)
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 
 set(ROOT_DIR "${PROJECT_SOURCE_DIR}")
 
+if (MSVC)
+  add_compile_options("/std:c++17")
+else()
+  add_compile_options(-std=c++17)
+endif()
+
+if(CMAKE_GNU_COMPILER_ID OR CMAKE_Clang_COMPILER_ID)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-format-security -Wno-format-truncation")
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-format-security -Wno-format-truncation -std=c++17")
+endif()
+
 # the next line is the ONLY place in the entire laszip system where
 # the version info is hard-coded
-set(LASZIP_API_VERSION_STRING "3.5.0" CACHE STRING "LASzip version" FORCE)
+set(LASZIP_API_VERSION_STRING "3.5.1" CACHE STRING "LASzip version" FORCE)
 
 include (CheckIncludeFileCXX)
 include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

=== dll/CMakeLists.txt ===
set(LASZIP_API_SOURCES
    laszip_api.h
    laszip_api.c
)

LASZIP_ADD_LIBRARY(${LASZIP_API_LIB_NAME} ${LASZIP_API_SOURCES})
LASZIP_ADD_INCLUDES("laszip" "${CMAKE_CURRENT_SOURCE_DIR}/laszip_api.h" "${CMAKE_SOURCE_DIR}/include/laszip/laszip_common.h" ${LASZIP_API_VERSION_H})

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
     
 if(WIN32)
 if(NOT BUILD_STATIC)
-    add_definitions("-DLASZIP_DLL_IMPORT=1")
+    add_definitions("-DLASZIP_DLL_IMPORTS=1")
 endif()
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -6,26 +6,71 @@
 #
 ###############################################################################
 set(LASZIP_SOURCES
+    mydefs.cpp
+    mydefs.hpp
+    lasmessage.cpp
+    lasmessage.hpp
     arithmeticdecoder.cpp
+    arithmeticdecoder.hpp
     arithmeticencoder.cpp
+    arithmeticencoder.hpp
     arithmeticmodel.cpp
+    arithmeticmodel.hpp
+    bytestreamin.hpp
+    bytestreamin_array.hpp
+    bytestreamin_file.hpp
+    bytestreamin_istream.hpp
+    bytestreaminout.hpp
+    bytestreaminout_file.hpp
+    bytestreamout.hpp
+    bytestreamout_array.hpp
+    bytestreamout_file.hpp
+    bytestreamout_nil.hpp
+    bytestreamout_ostream.hpp
+    endian.hpp
     integercompressor.cpp
+    integercompressor.hpp
+    lasattributer.hpp
     lasindex.cpp
+    lasindex.hpp
     lasinterval.cpp
+    lasinterval.hpp
+    laspoint.hpp
     lasquadtree.cpp
+    lasquadtree.hpp
+    lasquantizer.hpp
+    lasreaditem.hpp
     lasreaditemcompressed_v1.cpp
+    lasreaditemcompressed_v1.hpp
     lasreaditemcompressed_v2.cpp
+    lasreaditemcompressed_v2.hpp
     lasreaditemcompressed_v3.cpp
+    lasreaditemcompressed_v3.hpp
     lasreaditemcompressed_v4.cpp
+    lasreaditemcompressed_v4.hpp
+    lasreaditemraw.hpp
     lasreadpoint.cpp
+    lasreadpoint.hpp
+    laswriteitem.hpp
     laswriteitemcompressed_v1.cpp
+    laswriteitemcompressed_v1.hpp
     laswriteitemcompressed_v2.cpp
+    laswriteitemcompressed_v2.hpp
     laswriteitemcompressed_v3.cpp
+    laswriteitemcompressed_v3.hpp
     laswriteitemcompressed_v4.cpp
+    laswriteitemcompressed_v4.hpp
+    laswriteitemraw.hpp
     laswritepoint.cpp
+    laswritepoint.hpp
     laszip.cpp
+    laszip.hpp
+    laszip_common_v1.hpp
+    laszip_common_v2.hpp
+    laszip_common_v3.hpp
+    laszip_decompress_selective_v3.hpp
+    ../include/laszip/laszip_common.h
     laszip_dll.cpp
-    mydefs.cpp
 )
 
 add_definitions(-DLASZIPDLL_EXPORTS)

=== debian/changelog ===
laszip (3.5.0+really3.5.0-1) unstable; urgency=medium

  * New upstream version 3.5.0+really3.5.0
    - This brings the Debian version back in line with upstream's
      versioning scheme, which confusingly uses two different
      version numbers for the same release.
  * Refresh patches (no functional changes)
  * Add .symbols files for ABI tracking
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Migrate debian/watch to version 5 format

 -- Timo Röhling <roehling@debian.org>  Mon, 08 Dec 2025 18:11:34 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/laszip
 Vcs-Git: https://salsa.debian.org/science-team/laszip.git
 Homepage: https://laszip.org/
@@ -34,9 +34,9 @@
 Multi-Arch: same
 Section: libs
 Depends:
+ liblaszip8 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
- liblaszip8 (= ${binary:Version}),
 Pre-Depends:
  ${misc:Pre-Depends},
 Description: ${source:Synopsis} - API shared library
@@ -49,9 +49,9 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- ${misc:Depends},
  liblaszip-api8 (= ${binary:Version}),
  liblaszip8 (= ${binary:Version}),
+ ${misc:Depends},
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}
  .

=== debian/watch ===
Version: 5

Template: Github
Owner: LASzip
Project: LASzip
Dversion-Mangle: auto
Uversion-Mangle: auto
